import java.io.FileNotFoundException;
import java.io.FileReader;
import java.io.PrintWriter;
import java.util.ArrayList;
import java.util.Arrays;

import com.google.gson.Gson;
import com.google.gson.GsonBuilder;
import com.google.gson.JsonIOException;
import com.google.gson.JsonSyntaxException;

/*
 * Implementa la relació entre
 * el model DAO basat en CRUD
 * i el model de la base de dades real
 */

public class DaoCurs implements Dao<ObjCurs> {

    private void writeList (ArrayList<ObjCurs> llista) {
        try {
            Gson gson = new GsonBuilder().setPrettyPrinting().create();
            String jsonInString = gson.toJson(llista);
            PrintWriter out = new PrintWriter(MainDao.cursosPath);
            out.write(jsonInString);
            out.flush();
            out.close();
        } catch (JsonSyntaxException | JsonIOException | FileNotFoundException e) {
            e.printStackTrace();
        }
    }

    private int getPosition (int id) {
        int result = -1;
        ArrayList<ObjCurs> llista = getAll();
        for (int cnt = 0; cnt < llista.size(); cnt = cnt + 1) {
            ObjCurs curs = llista.get(cnt);
            if (curs.getId() == id) {
                result = cnt;
                break;
            }
        }
        return result;
    }

    @Override
    public void add(ObjCurs curs) {
        ArrayList<ObjCurs> llista = getAll();
        ObjCurs item = get(curs.getId());
        if (item == null) {
            llista.add(curs);
            writeList(llista);
        }
    }

    @Override
    public ObjCurs get(int id) {
        ObjCurs result = null;
        ArrayList<ObjCurs> llista = getAll();
        int pos = getPosition(id);
        if (pos != -1) {
            result = llista.get(pos);
        }
        return result;
    }

    @Override
    public ArrayList<ObjCurs> getAll() {
        ArrayList<ObjCurs> result = null;
        try {
            Gson gson = new Gson();
            ObjCurs[] arr = gson.fromJson(new FileReader(MainDao.cursosPath), ObjCurs[].class);
            result = new ArrayList<ObjCurs>(Arrays.asList(arr));
        } catch (JsonSyntaxException | JsonIOException | FileNotFoundException e) {
            e.printStackTrace();
        }
        return result;
    }

    @Override
    public void update(int id, ObjCurs curs) {
        ArrayList<ObjCurs> llista = getAll();
        int pos = getPosition(id);
        if (pos != -1) {
            llista.set(pos, curs);
            writeList(llista);
        }
    }

    @Override
    public void delete(int id) {
        ArrayList<ObjCurs> llista = getAll();
        int pos = getPosition(id);
        if (pos != -1) {
            llista.remove(pos);
            writeList(llista);
        }
    }

    @Override
    public void print () {
        ArrayList<ObjCurs> llista = getAll();
        for (int cnt = 0; cnt < llista.size(); cnt = cnt + 1) {
            System.out.println("    " + llista.get(cnt));
        }
    }
}
