import java.io.FileReader;
import java.io.IOException;
import java.io.PrintWriter;
import java.util.ArrayList;

import com.google.gson.Gson;
import com.google.gson.GsonBuilder;

/*
 * En aquest exemple s'escriu i es llegeix
 * un arxiu Json sense cap model d'accés a dades
 * directament transformant un Objecte a Json
 * i després al revés de Json a Objecte
 */

public class MainExempleJson {

    public static void main(String[] args) {
        String basePath = System.getProperty("user.dir") + "/";
        String filePath = basePath + "Doraemon.json";

        ArrayList<String> aficions = new ArrayList<>();
        aficions.add("Dormir");
        aficions.add("Jugar");
        aficions.add("Fer-se el llest");

        ObjPersonatge objOut = new ObjPersonatge("Doraemon", "Gat", "cosmic@dorayaki.jp", 1980, aficions);

        try {   
            // Escriure un objecte a Json 
            Gson gson = new GsonBuilder().setPrettyPrinting().create();
            String jsonInString = gson.toJson(objOut);
            System.out.println(jsonInString);
            PrintWriter out = new PrintWriter(filePath);
            out.write(jsonInString);
            out.flush();
            out.close();

            // Legir un Json a objecte
            ObjPersonatge objIn = gson.fromJson(new FileReader(filePath), ObjPersonatge.class);
            System.out.println("Persona: " + objIn);

        } catch (IOException e) { e.printStackTrace(); }
    }
}